# -*- coding: utf-8 -*-

require 'savon'
	
# Class Request
class Request
	
	attr_accessor :TransactionType 
    attr_accessor :GatewayUserName 
    attr_accessor :GatewayPassword 
    attr_accessor :PaymentType 
    attr_accessor :Amount 
    attr_accessor :Tax 
    attr_accessor :Shipping 
    attr_accessor :OrderDescription 
    attr_accessor :OrderID 
    attr_accessor :PONumber 
    attr_accessor :CCNumber 
    attr_accessor :CCExpDate 
    attr_accessor :CVV 
    attr_accessor :CheckName 
    attr_accessor :CheckABA 
    attr_accessor :CheckAccount 
    attr_accessor :AccountHolderType 
    attr_accessor :AccountType 
    attr_accessor :SecCode 
    attr_accessor :FirstName 
    attr_accessor :LastName 
    attr_accessor :Company 
    attr_accessor :Address1 
    attr_accessor :Address2 
    attr_accessor :City 
    attr_accessor :State 
    attr_accessor :Zip 
    attr_accessor :Country 
    attr_accessor :Phone 
    attr_accessor :Fax 
    attr_accessor :EMail 
    attr_accessor :Website 
    attr_accessor :ShippingFirstName 
    attr_accessor :ShippingLastName 
    attr_accessor :ShippingCompany 
    attr_accessor :ShippingAddress1 
    attr_accessor :ShippingAddress2 
    attr_accessor :ShippingCity 
    attr_accessor :ShippingState 
    attr_accessor :ShippingZip 
    attr_accessor :ShippingCountry 
    attr_accessor :ShippingEmail 
    attr_accessor :ShippingPhone 
    attr_accessor :ShippingFax 
    attr_accessor :ProcessorID 
    attr_accessor :TransactionID 
    attr_accessor :Tracking_Number 
    attr_accessor :Shipping_Carrier 
    attr_accessor :IPAddress 
    attr_accessor :Track1 
    attr_accessor :Track2 
    attr_accessor :Track3 
    attr_accessor :Track_Type 
    attr_accessor :Custom_Field_1 
    attr_accessor :Custom_Field_2 
    attr_accessor :Custom_Field_3 
    attr_accessor :Custom_Field_4 
    attr_accessor :Custom_Field_5 
    attr_accessor :Custom_Field_6 
    attr_accessor :Custom_Field_7 
    attr_accessor :Custom_Field_8 
    attr_accessor :Custom_Field_9 
    attr_accessor :Custom_Field_10 
    attr_accessor :SAFE_Action 
    attr_accessor :SAFE_ID 
    attr_accessor :ReceiptType 
    attr_accessor :MICR 
    attr_accessor :MICRSymbolSet 
    attr_accessor :CheckFrontTIFF 
    attr_accessor :CheckBackTIFF 
    attr_accessor :CheckNumber 
    attr_accessor :Terminal_ID 
    attr_accessor :CCNumber2 
    attr_accessor :Clerk_ID 
    attr_accessor :Billing_Code 
    attr_accessor :InvoiceID 
    attr_accessor :BatchID 
    attr_accessor :DLNumber 
    attr_accessor :DLState 
    attr_accessor :IdentityVerification 
    attr_accessor :CourtesyCardID 
    attr_accessor :MagData 

	def initialize()
		@TransactionType = ""
	    @GatewayUserName = ""
	    @GatewayPassword = ""
	    @PaymentType = ""
	    @Amount = ""
	    @Tax = ""
	    @Shipping = ""
	    @OrderDescription = ""
	    @OrderID = ""
	    @PONumber = ""
	    @CCNumber = ""
	    @CCExpDate = ""
	    @CVV = ""
	    @CheckName = ""
	    @CheckABA = ""
	    @CheckAccount = ""
	    @AccountHolderType = ""
	    @AccountType = ""
	    @SecCode = ""
	    @FirstName = ""
	    @LastName = ""
	    @Company = ""
	    @Address1 = ""
	    @Address2 = ""
	    @City = ""
	    @State = ""
	    @Zip = ""
	    @Country = ""
	    @Phone = ""
	    @Fax = ""
	    @EMail = ""
	    @Website = ""
	    @ShippingFirstName = ""
	    @ShippingLastName = ""
	    @ShippingCompany = ""
	    @ShippingAddress1 = ""
	    @ShippingAddress2 = ""
	    @ShippingCity = ""
	    @ShippingState = ""
	    @ShippingZip = ""
	    @ShippingCountry = ""
	    @ShippingEmail = ""
	    @ShippingPhone = ""
	    @ShippingFax = ""
	    @ProcessorID = ""
	    @TransactionID = ""
	    @Tracking_Number = ""
	    @Shipping_Carrier = ""
	    @IPAddress = ""
	    @Track1 = ""
	    @Track2 = ""
	    @Track3 = ""
	    @Track_Type = ""
	    @Custom_Field_1 = ""
	    @Custom_Field_2 = ""
	    @Custom_Field_3 = ""
	    @Custom_Field_4 = ""
	    @Custom_Field_5 = ""
	    @Custom_Field_6 = ""
	    @Custom_Field_7 = ""
	    @Custom_Field_8 = ""
	    @Custom_Field_9 = ""
	    @Custom_Field_10 = ""
	    @SAFE_Action = ""
	    @SAFE_ID = ""
	    @ReceiptType = ""
	    @MICR = ""
	    @MICRSymbolSet = ""
	    @CheckFrontTIFF = ""
	    @CheckBackTIFF = ""
	    @CheckNumber = ""
	    @Terminal_ID = ""
	    @CCNumber2 = ""
	    @Clerk_ID = ""
	    @Billing_Code = ""
	    @InvoiceID = ""
	    @BatchID = ""
	    @DLNumber = ""
	    @DLState = ""
	    @IdentityVerification = ""
	    @CourtesyCardID = ""
	    @MagData = ""
	end
end

# Class Response
class Response

	attr_accessor :STATUS_CODE 
    attr_accessor :STATUS_MSG 
    attr_accessor :TRANS_ID 
    attr_accessor :AUTH_CODE 
    attr_accessor :AVS_CODE 
    attr_accessor :AVS_MSG 
    attr_accessor :CVV2_CODE 
    attr_accessor :CVV2_MSG 
    attr_accessor :ORDERID 
    attr_accessor :SAFE_ID 
    attr_accessor :FULLRESPONSE 
    attr_accessor :POSTSTRING 
    attr_accessor :BALANCE 
    attr_accessor :GIFTRESPONSE 
    attr_accessor :MERCHANT_ID 
    attr_accessor :CUSTOMER_MESSAGE 

	def initialize()
		@STATUS_CODE = ""
        @STATUS_MSG = ""
        @TRANS_ID = ""
        @AUTH_CODE = ""
        @AVS_CODE = ""
        @AVS_MSG = ""
        @CVV2_CODE = ""
        @CVV2_MSG = ""
        @ORDERID = ""
        @SAFE_ID = ""
        @FULLRESPONSE = ""
        @POSTSTRING = ""
        @BALANCE = ""
        @GIFTRESPONSE = ""
        @MERCHANT_ID = ""
        @CUSTOMER_MESSAGE = ""

    end
end

# Class AgmsAPI
class AgmsAPI
	def initialize()
	end

	def ProcessTransaction(request)
		response = Response.new

		client = Savon.client(wsdl: "https://gateway.agms.com/roxapi/agms.asmx?WSDL", namespace: "https://gateway.agms.com/roxapi/")
		
		res = client.call(:process_transaction, message: {"objparameters" => request})
		res = res.body
		response.STATUS_CODE = res[:process_transaction_response][:process_transaction_result][:status_code]
		response.STATUS_MSG = res[:process_transaction_response][:process_transaction_result][:status_msg]
		response.TRANS_ID = res[:process_transaction_response][:process_transaction_result][:trans_id]
		response.AUTH_CODE = res[:process_transaction_response][:process_transaction_result][:auth_code]
		response.AVS_CODE = res[:process_transaction_response][:process_transaction_result][:avs_code]
		response.AVS_MSG = res[:process_transaction_response][:process_transaction_result][:avs_msg]
		response.CVV2_CODE = res[:process_transaction_response][:process_transaction_result][:cvv2_code]
		response.CVV2_MSG = res[:process_transaction_response][:process_transaction_result][:cvv2_msg]
		response.ORDERID = res[:process_transaction_response][:process_transaction_result][:orderid]
		response.SAFE_ID = res[:process_transaction_response][:process_transaction_result][:safe_id]
		response.FULLRESPONSE = res[:process_transaction_response][:process_transaction_result][:fullresponse]
		response.POSTSTRING = res[:process_transaction_response][:process_transaction_result][:poststring]
		response.BALANCE = res[:process_transaction_response][:process_transaction_result][:balance]
		response.GIFTRESPONSE = res[:process_transaction_response][:process_transaction_result][:giftresponse]
		response.MERCHANT_ID = res[:process_transaction_response][:process_transaction_result][:merchant_id]
		response.CUSTOMER_MESSAGE = res[:process_transaction_response][:process_transaction_result][:customer_message]
		return response
	end
end