#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
require './Agms.rb'

request = {
	"GatewayUserName" => "your username",
    "GatewayPassword" => "your password",
	"TransactionType" => "sale",
	"PaymentType" => "creditcard",
	"Amount" => "1.00",
	"CCNumber" => "4111111111111111",
	"CCExpDate" => "0120",
	"CVV" => "123"
}

agms = AgmsAPI.new
response = agms.ProcessTransaction(request)

print "Status Code: #{response.STATUS_CODE} \n"
print "Status Message: #{response.STATUS_MSG} \n"
print "Transaction Id: #{response.TRANS_ID} \n"
print "Auth Code: #{response.AUTH_CODE} \n"
print "Avs Code: #{response.AVS_CODE} \n"
print "Avs Message: #{response.AVS_MSG} \n"
print "CVV2 Code: #{response.CVV2_CODE} \n"
print "CVV2 Msg: #{response.CVV2_MSG} \n"
print "Order Id: #{response.ORDERID} \n"
print "Safe Id: #{response.SAFE_ID} \n"
print "Full Response #{response.FULLRESPONSE} \n"
print "Post String: #{response.POSTSTRING} \n"
print "Balance: #{response.BALANCE} \n"
print "Gift Response: #{response.GIFTRESPONSE} \n"
print "Merchant Id: #{response.MERCHANT_ID} \n"
print "Customer Message: #{response.CUSTOMER_MESSAGE} \n"
